



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用Metrics监控应用程序的性能</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用Metrics监控应用程序的性能</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 18:40:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在编写应用程序的时候，通常会记录日志以便事后分析，在很多情况下是产生了问题之后，再去查看日志，是一种事后的静态分析。在很多时候，我们可能需要了解整个系统在当前，或者某一时刻运行的情况，比如当前系统中对外提供了多少次服务，这些服务的响应时间是多少，随时间变化的情况是什么样的，系统出错的频率是多少。这些动态的准实时信息对于监控整个系统的运行健康状况来说很重要。</p>
<p>一些应用程序，比如对外提供接口或者服务的WebService，对整个系统的实时运行情况进行监控显得尤为重要，着就像我们操作系统里面的资源管理器一样，如果能够实时或者准实时的看到整个系统耗费的CPU，内存等资源，对我们快速对系统做出响应，以及优化很重要。并且，这些实时的性能参数信息，对于一些高级应用场景，比如<a href="http://www.cnblogs.com/yangecnu/p/Introduce-Circuit-Breaker-Pattern.html" rel="external nofollow noreferrer">服务的熔断</a>机制（需要实时统计系统出错比例和响应时间），只有做到了实时监控才能提供这些数据，才能实现这种提高系统稳健性的功能。</p>
<p>前几天在InfoQ的<a href="http://www.cnblogs.com/1.%09http:/www.infoq.com/cn/articles/interview-alibaba-zhaohaiping" rel="external nofollow noreferrer">一篇采访文章</a>中看到一句话 &ldquo;Profiling特别重要。如果能有一个特别强大的Profiling系统，就知道整个系统在哪个地方，哪台机器上，花了多少CPU、内存、磁盘IO或者网络带宽等资源，才能知道优化什么地方效益最大。&rdquo;</p>
<p>同样，对于WebService的监控，比如在那个地方，那台机器上，花了多少CPU，多少内存，每一个服务的响应时间，出错的次数频率等，这些信息记录下来之后，我们就可以看到服务在运行时的动态的表现，更加容易找出错误或者定位问题点来进行优化。</p>
<p>最简单的做法是，在应用系统的关键地方，或者所有程序的入口，出口进行埋点，然后将这些采样信息不断的发送到某一个消息队列或者内存DB中，然后其他系统进行读取分析和展示。</p>
<p>在Java中有一个开源的名为<a href="https://dropwizard.github.io/metrics/3.1.0/" rel="external nofollow noreferrer">Metrics</a>的项目，它能够捕获JVM以及应用层面的性能参数，他的作者Coda Hale介绍了什么是Mertics并且为什么Metrics在应用程序系统中很有必要，视频和演讲可以分别到<a href="https://www.youtube.com/watch?v=czes-oa0yik" rel="external nofollow noreferrer">YouTube</a>和<a href="https://dl.dropboxusercontent.com/u/2744222/2011-04-09-Metrics-Metrics-Everywhere.pdf" rel="external nofollow noreferrer">SlideShare</a>上可以下载。在.NET中有对其进行移植的项目叫 <a href="https://github.com/etishor/Metrics.NET" rel="external nofollow noreferrer">Metrics.NET</a>。</p>
<p>在开始介绍Metric之前，需要先看看一些基本的度量器类型，以及常见的使用场景，才能知道如何使用。</p>
<h1>一 度量类型</h1>
<p>Metrics提供5种基本的度量类型：Gauges, Counters, Histograms, Meters和 Timers</p>
<h2>Gauge</h2>
<p>Gauge是最简单的度量类型，只有一个简单的返回值，他用来记录一些对象或者事物的瞬时值。</p>
<p>比如，我们类型为Gauge的计数器来记录某个服务目前开通的城市个数</p>
<pre class="prettyprint linenums">Metric.Gauge("Service Cities Count", () =&gt; Cities.Count, new Unit("个"));</pre>
<h2>Counters</h2>
<p>Counter是一个简单64位的计数器，他可以增加和减少。</p>
<p>比如我们可以定义两个Counter类型的计数器，用来统计所有服务请求数目，和目前正在处理的请求总数。</p>
<pre class="prettyprint linenums">/// &lt;summary&gt;
/// keep the total count of the requests
/// &lt;/summary&gt;
private readonly Counter totalRequestsCounter = Metric.Counter("Requests", Unit.Requests);

/// &lt;summary&gt;
/// count the current concurrent requests
/// &lt;/summary&gt;
private readonly Counter concurrentRequestsCounter = Metric.Counter("SampleMetrics.ConcurrentRequests", Unit.Requests);
</pre>
<p>这样，在我们请求处理开始的时候，同时将这两个计数器自增。</p>
<pre class="prettyprint linenums">this.concurrentRequestsCounter.Increment(); // increment concurrent requests counter
this.totalRequestsCounter.Increment(); // increment total requests counter </pre>
<p>当某一个请求处理完成之后，将目前正在处理的请求减一</p>
<pre class="prettyprint linenums">this.concurrentRequestsCounter.Decrement(); // decrement number of concurrent requests</pre>
<p>这种计数器也可以用来统计诸如当前有多少人在线，或者服务器中有多少处于有效期内的session</p>
<h2>Meters</h2>
<p>Meter是一种只能自增的计数器，通常用来度量一系列事件发生的比率。他提供了平均速率，以及指数平滑平均速率，以及采样后的1分钟，5分钟，15分钟速率。</p>
<p>比如需要统计请求的速率，比如统计平均每分钟内有多少次请求进来。只需要定义一个metric</p>
<pre class="prettyprint linenums">/// &lt;summary&gt;
/// measure the rate at which requests come in
/// &lt;/summary&gt;
private readonly Meter meter = Metric.Meter("Requests", Unit.Requests,TimeUnit.Seconds);</pre>
<p>在处理请求的地方，调用Mark方法即可。</p>
<pre class="prettyprint linenums">this.meter.Mark(); // signal a new request to the meter</pre>
<p>再比如，要测量服务出错的概率，比如每小时出错多少次。可以定义一个metric。</p>
<pre class="prettyprint linenums">/// &lt;summary&gt;
/// measure the rate of service exception
/// &lt;/summary&gt;
private readonly Meter errorMeter = Metric.Meter("Error", Unit.Errors, TimeUnit.Hours);</pre>
<p>这样，在处理请求的时候，如果出现异常了，调用一下errorMeter的Mark方法即可。</p>
<pre class="prettyprint linenums">this.errorMeter.Mark();// signal a new error to the meter</pre>
<h2>Histograms</h2>
<p>Histrogram是用来度量流数据中Value的分布情况，Histrogram可以计算最大/小值、平均值，方差，分位数（如中位数，或者95th分位数），如75%,90%,98%,99%的数据在哪个范围内。</p>
<p>比如，我们想度量，所有传进来服务的请求参数的长度分布。那么，可以定义一个histogram。</p>
<pre class="prettyprint linenums">/// &lt;summary&gt;
/// keep a histogram of the input data of our request method
/// &lt;/summary&gt;
private readonly Histogram histogramOfData = Metric.Histogram("ResultsExample", Unit.Items);</pre>
<p>然后在请求的地方，调用其Update方法来更新值。</p>
<pre class="prettyprint linenums">this.histogramOfData.Update(request.length, methodName); // update the histogram with the input data</pre>
<h2>Timer</h2>
<p>Timer是Histogram跟Meter的一个组合，比如要统计当前请求的速率和处理时间。</p>
<p>就可以定义一个Timer:</p>
<pre class="prettyprint linenums">/// &lt;summary&gt;
/// measure the time rate and duration of requests
/// &lt;/summary&gt;
private readonly Timer timer = Metric.Timer("Requests", Unit.Requests);</pre>
<p>在使用的时候，调用timer的NewContext即可。</p>
<pre class="prettyprint linenums">using (this.timer.NewContext(i.ToString())) // measure until disposed
{
    ...
}</pre>
<h1>二 度量数据的输出</h1>
<p>收集了这么多数据之后，我们需要把数据时实的动态展示或者保存起来。Metric提供了多种的数据报告接口。包括自带的<a href="https://github.com/etishor/Metrics.NET.FlotVisualization" rel="external nofollow noreferrer">Metrics.NET.FlotVisualization</a>， 以及输出到专业的系统监控Graphite，输出到开源，分布式，时间序列的中<a href="http://influxdb.org/" rel="external nofollow noreferrer">InfluxDB</a>，或者输出到ElasticSearch中。<a href="https://github.com/etishor/Metrics.NET/wiki/Metrics-Reporting" rel="external nofollow noreferrer">配置</a>起来也非常简单。比如如果要直接在http页面上展现，只需要在初始化的时候，设置合适的EndPoint即可:</p>
<pre class="prettyprint linenums">Metric.Config
    .WithHttpEndpoint("http://localhost:1234/metrics/")
    .WithAllCounters()
    .WithInternalMetrics()
    .WithReporting(config =&gt; config
        .WithConsoleReport(TimeSpan.FromSeconds(30))</pre>
<p>然后在浏览器中输入 <a href="http://localhost:1234/metrics/" rel="external nofollow noreferrer">http://localhost:1234/metrics/</a>，就可以看到各种采集的准实时各种度量信息：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/94031/201504/302334122552628.gif" /></p>
<p>上面自带的性能DashBoard略显简陋。 通常，我们一般会将这些实时采集的数据存储到分布式时序数据库<a href="http://influxdb.org/" rel="external nofollow noreferrer">InfluxDB</a>中，然后利用开源的图表控件<a href="http://grafana.org/" rel="external nofollow noreferrer">Grafana</a>来实时展现这些数据，比如，可以制作想下面这样的，动态的性能准实时监控系统：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/94031/201504/302334208182678.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/94031/201504/302334262407988.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/94031/201504/302334357249824.png" /></p>
<h1>三 总结</h1>
<p>本文介绍了如何使用埋点和各种度量工具来实时监测应用程序的性能，介绍了.NET中Metrics度量工具的使用。与传统的记录日志的方式不同，这种实时或者准实时的对当前系统各种关键指标的采样和监控，对于应用程序的运维，性能优化，提供了一种动态的视角，能帮助我们更好的了解当前应用程序或者服务在线上的各种性能参数和表现状态。Metrics的采样应该尽量减少对原有系统的侵入性，所以一般的最好是将采样的结果存储到消息队列或者内存DB中，然后进行动态展示，另外采样频率也是需要考虑的一个重要因素。因为对于一个较大的系统来说，实时采样产生的数据量会比较大。<a href="http://influxdb.org/" rel="external nofollow noreferrer">InfluxDB</a> 似乎只能在非Windows平台使用，所以本文没有完整演示整个<a href="https://github.com/etishor/Metrics.NET" rel="external nofollow noreferrer">Metrics</a>+<a href="http://influxdb.org/" rel="external nofollow noreferrer">InfluxDB</a>+<a href="http://grafana.org/" rel="external nofollow noreferrer">Grafana</a> 构建应用程序实时监控系统的搭建。不过相信大家对照着相关文档，应该不难实现。</p>
<p>希望本文对您了解如何实时监控应用程序性能，以及如何构建应用程序性能参数dashboard有所帮助。</p>
<h2>四 参考资料</h2>
<ul><li><a href="http://www.infoq.com/cn/articles/interview-alibaba-zhaohaiping" rel="external nofollow noreferrer">http://www.infoq.com/cn/articles/interview-alibaba-zhaohaiping</a></li>
<li><a href="https://github.com/etishor/Metrics.NET" rel="external nofollow noreferrer">https://github.com/etishor/Metrics.NET</a></li>
<li><a href="http://www.cnblogs.com/shanyou/p/4004711.html" rel="external nofollow noreferrer">http://www.cnblogs.com/shanyou/p/4004711.html</a></li>
<li><a href="http://influxdb.com/" rel="external nofollow noreferrer">http://influxdb.com/</a></li>
<li><a href="http://grafana.org/" rel="external nofollow noreferrer">http://grafana.org/</a></li>
<li><a href="http://xiaorui.cc/tag/influxdb/" rel="external nofollow noreferrer">http://xiaorui.cc/tag/influxdb/</a></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495zzv9z.html">AngularJS实例实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mn6r6q.html">c&num;委托----我的一点笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4wyz39.html">JavaScript学习笔记-随滚轮匀速滑动的浮动广告窗动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0p5kq.html">LeetCode House Robber</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8omwzlq.html">iOS 通过二进制判断图片类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1g15v9.html">&lbrack;reprint&rsqb;useful linux commands</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11rdd9.html">Java中List、Collections实现梭哈游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y4p3nq.html">离散-ACM一道强有力的工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde5mpj9.html">HDU 3294 &lpar;Manacher&rpar; Girls&amp;&num;39&semi; research</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1l2or9.html">c&num;面向对象小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vgw038.html">STL中，back&lowbar;insert&lowbar;iterator与back&lowbar;inserter的区别。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojj00lq.html">android内置存储器memory和第三方外部存储disk管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j3g3x8.html">Docker for windows10 配置镜像加速</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0o239.html">【转】BTree&comma;B-Tree&comma;B&plus;Tree&comma;B&ast;Tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jpkdv8.html">Asp&period;Net Core配置Swagger</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvjozx8.html">cmd下的一些小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zykvv39.html">Centos 7下VMware三台虚拟机Hadoop集群初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvz7ly8.html">JS进阶之---this的指向</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldzk6q.html">gSOAP 在windows下的安装与使用（mingw32）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnd2e2q.html">hadoop自动提交脚本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/eoqv1qxn.html">mapreduce多文件输出的两方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/or93yn83.html">试试SQLSERVER2014的内存优化表</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn12j8r.html">DDD 领域驱动设计－看我如何应对业务需求变化，愚蠢的应对？</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z1en9y.html">JAVA语言中的修饰符</a>
			</li>
						<li><a href="https://www.batexi.com/a/39023oqd.html">iOS微信里打开app，Universal Links</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mj0p8k.html">JavaScript基础知识总结（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gpol97.html">golang语言构造函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pm179x.html">javascript有用小功能总结&lpar;未完待续&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pkwy8x.html">jQuery禁用或启用</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1p7zqg.html">iOS开源项目周报1215</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
